;##################################
; Options
;##################################
AutoItSetOption("WinTitleMatchMode", 4)

Global $winTitle = "Sacred";Name of game
Global $hWnd = WinGetHandle("Sacred");Name of game
Global $Sacred = _OpenProcess($hWnd);Name of game

;##################################
; Function for reading
; Game Memory
;##################################
Func Read_SACRED_memory()
			$currentlocation = _ReadString($Sacred, 0x00BD21D2, 700)
;			  ToolTip("Location: " & $currentlocation, 0, 0); Displays the currentlocation
	  Sleep(10)
	 EndFunc

;##################################
; Function call
; Current Player 'HP', 'MP', Gold Values.
;##################################
;While 1
;	Read_Sacred_memory()
;	Sleep(10)
;WEnd

; Closes memory on Exit
Func OnAutoItExit ( )
_CloseHandle($Sacred)
EndFunc

; Functions for the above memory reading. DON'T CHANGE THEM AT ALL!!!!

;--Memory Functions--
Func _OpenProcess($hWnd, $use_pid=0)
	If $use_pid = 0 Then
		Local $pid = DllCall("user32.dll", "int", "GetWindowThreadProcessId", "hwnd", $hWnd, "int_ptr", 0)
		If IsArray($pid) Then
			$pid = $pid[2]
		Else
			SetError(-1)
			Return
		EndIf
	Else
		Local $pid = $hWnd
	EndIf
	
	Local $pHandle = DllCall("kernel32.dll", "int", "OpenProcess", "int", 0x1F0FFF, "int", 0, "int", $pid)
	If IsArray($pHandle) And $pHandle[0] > 0 Then
		$pHandle = $pHandle[0]
	Else
		SetError(-2)
		Return
	EndIf
	
	Return $pHandle
EndFunc

Func _CloseHandle($pHandle)
	DllCall("kernel32.dll", "int", "CloseHandle", "int", $pHandle)
EndFunc

Func _ReadMemory($pHandle, $Address, $size)
	Local $ret = DllCall("kernel32.dll", "int", "ReadProcessMemory", "int", $pHandle, "int", $Address, "int_ptr", 0, "int", $size, "int", 0)
	If IsArray($ret) Then
		If $ret[0] = 1 Then
			$ret = $ret[3]
		Else
			SetError(-2)
			Return
		EndIf
	Else
		SetError(-1)
		Return
	EndIf

	
	Return $ret
EndFunc

Func _ReadFloat($pHandle, $Address)
	Local $floatReturn = 0
	Local $float = DllStructCreate("float")
	Local $ret = DllCall("kernel32.dll", "int", "ReadProcessMemory", "int", $pHandle, "int", $Address, "ptr", DllStructGetPtr($float), "int", 4, "int", 0)
	If IsArray($ret) Then
		If $ret[0] = 1 Then
			$floatReturn = DllStructGetData($float, 1)
		Else
			SetError(-1)
		EndIf
	Else
		SetError(-2)
	EndIf
	
	Return $floatReturn
EndFunc

Func _ReadString($pHandle, $Address, $length)
	Local $ret, $tmpStr = ""
	For $i = 0 To $length - 1
		$ret = DllCall("kernel32.dll", "int", "ReadProcessMemory", "int", $pHandle, "int", $Address + $i, "int_ptr", 0, "int", 1, "int", 0)
		If IsArray($ret) Then
			If $ret[0] = 1 Then
				If $ret[3] > 0 Then
					$tmpStr = $tmpStr & Chr($ret[3])
				Else
					ExitLoop
				EndIf
			Else
				SetError(-2)
				Return
			EndIf
		Else
			SetError(-1)
			Return
		EndIf
	Next
	
	Return $tmpStr
EndFunc

Func _WriteMemory($pHandle, $Address, $value, $size)
	Local $ret = DllCall("kernel32.dll", "int", "WriteProcessMemory", "int", $pHandle, "int", $Address, "int_ptr", $value, "int", $size, "int", 0)
	If IsArray($ret) Then
		If $ret[0] = 1 Then
			Return True
		Else
			SetError(-2)
			Return False
		EndIf
	Else
		SetError(-1)
		Return False
	EndIf
	
	Return True
EndFunc

Func _WriteFloat($pHandle, $Address, $value)
	Local $float = DllStructCreate("float")
	DllStructSetData($float, 1, $value)
	Local $ret = DllCall("kernel32.dll", "int", "WriteProcessMemory", "int", $pHandle, "int", $Address, "ptr", DllStructGetPtr($float), "int", 4, "int", 0)
	If IsArray($ret) Then
		If $ret[0] = 1 Then
			Return True
		Else
			SetError(-2)
			Return False
		EndIf
	Else
		SetError(-1)
		Return False
	EndIf
EndFunc

Func _WriteString($pHandle, $Address, $string)
	Local $ret
	Local $length = StringLen($string)
	For $i = 0 To $length		
		$ret = DllCall("kernel32.dll", "int", "WriteProcessMemory", "int", $pHandle, "int", $Address + $i, "int_ptr", Asc(StringMid($string, $i + 1, 1)), "int", 1, "int", 0)
		If IsArray($ret) Then
			If $ret[0] = 0 Then
				SetError(-2)
				Return False
			EndIf
		Else
			SetError(-1)
			Return False
		EndIf
	Next
	
	Return True
EndFunc
