;##################################
; Include
;##################################
; #include "verification.au3" ; not yet used atm. works but will be only used in final release - included without any problem
; #include "mailsender.au3" ; not yet used atm. works but will be only used in final release - included without any problem
#include "waypoints.au3"
#include "mem.au3"
#include "moving.au3"

;##################################
; ini-parameters
;##################################
Global $moveX= 512
Global $movey= 384
$version = "v1.0 "
$currentnumberofrun = 1
$password = IniRead( @ScriptDir & "\sacred.ini", "startup", "password", "default"); password for account
$type = IniRead( @ScriptDir & "\sacred.ini", "startup", "type", "default"); open or closed internet
$char = IniRead( @ScriptDir & "\sacred.ini", "startup", "char", "default"); type of char
$location = IniRead( @ScriptDir & "\sacred.ini", "startup", "location", "default"); location of char on matrix
$standarddelay = IniRead( @ScriptDir & "\sacred.ini", "timers", "standarddelay", "default") ; standard delay for game-creation mouseclicks
$gamestartdelay = IniRead( @ScriptDir & "\sacred.ini", "timers", "gamestartdelay", "default"); delay for game startup
$creategamedelay = IniRead( @ScriptDir & "\sacred.ini", "timers", "creategamedelay", "default"); delay for game-creation
$clickingdelay = IniRead( @ScriptDir & "\sacred.ini", "timers", "clickingdelay", "default") ; delay for in-game clicking
$welcomeboxdelay = IniRead( @ScriptDir & "\sacred.ini", "timers", "welcomebox", "default") ; delay to remove the welcomebox: "welcome to sacred underworld"
$serverslotdelay = IniRead( @ScriptDir & "\sacred.ini", "timers", "serverslots", "default") ; delay to let the serverslot load
$pw = Random(000000, 999999, 1)
$workingdir = RegRead("HKEY_CURRENT_USER\Software\Ascaron Entertainment\Sacred Underworld", "InstallLocation")
$executable = 'sacred.exe'
Global $Paused
HotKeySet("{F9}", "TogglePause")

;##################################
; main script
;##################################
$totalnumberofruns = InputBox( "Sacred bot " & $version, "How many runs would you like to do?", "", " M", 240, 115)
; backup's if ini-fields aren't filled in to retrieve info
While $password = ""
	$password = InputBox("Sacred bot " & $version, "PLEASE ENTER YOUR PASSWORD?", "", " M", 240, 115)
	$password2 = InputBox("Sacred bot " & $version, "PLEASE RE-ENTER YOUR PASSWORD", "", " M", 240, 115)
	If $password = $password2 Then ExitLoop
WEnd
While $type = ""
	$type = InputBox("Sacred bot " & $version, "OPEN OR CLOSED INTERNET?", "", " M6", 240, 115)
	If StringInStr($type, "open") Or StringInStr($type, "closed") Then ExitLoop
WEnd
While $char = ""
	$char = InputBox("Sacred bot " & $version, "ENTER CHARACTER TO USE FOR QUEST", "", " M1", 240, 115)
	If StringInStr($char, "1") Or StringInStr($char, "2") Or StringInStr($char, "3") Or StringInStr($char, "4") Or StringInStr($char, "5") Or StringInStr($char, "6") Or StringInStr($char, "7") Or StringInStr($char, "8") Then ExitLoop
WEnd
While $location = ""
	$location = InputBox("Sacred bot " & $version, "LOCATION OF CHARACTER ON MATRIX?", "", " M1", 240, 115)
	If StringInStr($location, "1") Or StringInStr($location, "2") Or StringInStr($location, "3") Or StringInStr($location, "4") Or StringInStr($location, "5") Or StringInStr($location, "6") Or StringInStr($location, "7") Or StringInStr($location, "8") Then ExitLoop
WEnd
MsgBox(0, "Sacred bot " & $version & "by Overlord and Sardith", "Please leave your mouse and keyboard so the bot can run. If needed, the bot can be paused by pressing F9", 5)
Run($workingdir & '\' & $executable, $workingdir) ; starting up the game
Sleep($gamestartdelay) ; delay to let the game load
mpstart() ; start a multiplayer game on open or closed internet
sleep($standarddelay) ; standarddelay
charselection() ; selecting the character in the selection-screen
sleep($standarddelay) ; standarddelay
creategame() ; create's a private game with random password
Sleep($creategamedelay) ; creategamedelay
Send("{ENTER}current run is "  & $currentnumberofrun & "{ENTER}") ; for testing purpose
sleep (2000)
;;setskill() not possible to do atm. x and y change so it seems. maybe we can solve this with the memory reading.
;; we only need to run this on the first loop.
$totalnumberofruns = $currentnumberofrun + 1

;##################################
;move to wp1 (3252,2854)
;##################################
$wpx = $wpx1
$wpy = $wpy1
moving()

#cs
Jeff,
I need you to take a look at the above walking part. Mousemovement does happen in the right direction but it seems
like he is only calculating his way ONCE. If he passes the point $wpx1 and $wpy1 he still keeps running in the same direction.
I merged the scripts that we where using together and got him walking. I think we are close to our first goal now.
#ce




;##################################
;main functions
;##################################
Func TogglePause() ; used to pause the script
	$Paused = Not $Paused
	While $Paused
		ToolTip("PAUSE",0,0)
		Sleep(100)
	WEnd
	EndFunc   ;==>TogglePause

Func mpstart() ; click for multiplayer startup
	MouseClick("left", 500, 350)
	if $type="open" then open()
	if $type="closed" then closed()
	EndFunc   ;==>mpstart

Func open() ; click for open internet
	MouseClick("left", 500, 380)
	Sleep($standarddelay) ; standarddelay
	Send($password)
	Send("{ENTER}")
	Sleep($welcomeboxdelay) ; welcomebox-click
	MouseClick("left", 515, 440)
	EndFunc   ;==>open

Func closed() ; click for closed internet
	MouseClick("left", 500, 345)
	Sleep($standarddelay) ; standarddelay
	Send($password)
	Send("{ENTER}")
	Sleep($welcomeboxdelay) ; welcomebox-click
	MouseClick("left", 515, 440)
	EndFunc   ;==>closed

Func charselection() ; char-location in game
	if $location = "1" then MouseClick("left", 100, 450, 2)
	if $location = "2" then MouseClick("left", 220, 450, 2)
	if $location = "3" then MouseClick("left", 370, 450, 2)
	if $location = "4" then MouseClick("left", 540, 450, 2)
	if $location = "5" then MouseClick("left", 630, 450, 2)
	if $location = "6" then MouseClick("left", 730, 450, 2)
	if $location = "7" then MouseClick("left", 830, 450, 2)
	if $location = "8" then MouseClick("left", 890, 450, 2)
	EndFunc   ;==>char-location

Func creategame() ; creates a private game with password
	MouseClick("left", 291, 61, 2)
	Sleep($serverslotdelay) ; serverslot-delay
	MouseClick("left", 300, 380)
	Sleep($standarddelay) ; standarddelay
	MouseClick("left", 300, 160)
	Send($pw)
	MouseClick("left", 450, 380)
	EndFunc   ;==>creategame

;; the other chars I still need to figure out what skill they can use
Func setskill() ; only used in first run. set the needed skill to what char u use. (skill depends on char to get over the river)
	If $char = "1" Then glstompjump()
	If $char = "2" Then Exit
	If $char = "3" Then Exit
	If $char = "4" Then Exit
	If $char = "5" Then bmphase()
	If $char = "6" Then vampclaw()
	If $char = "7" Then daemonsd()
	If $char = "8" Then Exit
	EndFunc   ;==>setskill
	
Func glstompjump() ; gladiator spell "stomping jump"
	Send("f")
	MouseClick("left", 47, 426)
	Sleep($clickingdelay)
	MouseClick("left", 670, 730)
	Sleep($clickingdelay)
	Send("f")
	EndFunc   ;==>glstompjump

Func bmphase(); battle-mage spell "phase-shift"
	Send("f")
	MouseClick("left", 288, 534)
	Sleep($clickingdelay)
	MouseClick("left", 670, 730)
	Sleep($clickingdelay)
	Send("f")
	EndFunc   ;==>bmphase

Func vampclaw(); vampire spell "claw jump"
	Send("f")
	MouseClick("left", 400, 490)
	Sleep($clickingdelay)
	MouseClick("left", 670, 730)
	Sleep($clickingdelay)
	Send("f")
	EndFunc   ;==>vampclaw

Func daemonsd() ; daemon spell "soaring demon"
	Send("f")
	MouseClick("left", 450, 560)
	Sleep($clickingdelay)
	MouseClick("left", 670, 730)
	Sleep($clickingdelay)
	Send("f")
	EndFunc   ;==>daemonsd

Func jumpoverriver()
	If $char = "1" Then Exit
	If $char = "2" Then Exit
	If $char = "3" Then Exit
	If $char = "4" Then Exit
	If $char = "5" Then bmoverriver()
	If $char = "6" Then Exit
	If $char = "7" Then Exit
	If $char = "8" Then Exit
	EndFunc   ;==>jumpoverriver
	
Func bmoverriver()
	MouseClick("right", 240, 617)
	EndFunc   ;==>bmoverriver

Func moving()
	While 1
		Do
		Read_SACRED_memory()
		ToolTip("Location: " & $currentlocation, 0, 0); Displays the currentlocation
		calculate_way2()
		ToolTip("moveX: " & $moveX & " moveY: " & $moveY,0,50)
;		If $currentx-$wpx Or $currenty-$wpy <=15 Then Send("{SHIFTDOWN}") ; difference between running/walking - for better accuracy
		MouseClick("left",$moveX,$moveY) ; as described in comments in moving.au3
;		Send("{SHIFTUP}")
		sleep($clickingdelay) ; delay for in-game clicking
		Until $currentx = $wpx1 and $currenty = $wpy1
		WEnd
	EndFunc   ;==>moving


















